/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 * åװ¸⥸塼AT91SAM7Sѡ
 */

#include "kernel_impl.h"
#include <sil.h>

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf;

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t	bitpat_cfgint;

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
    int i;
    
    /*
     *  ARM¸ν
     */
    core_initialize();


    /*
     * ϻ˳װȽꤹ뤿SVR˳ֹ򥻥åȤ
     */
    /*
     * ߶ػ
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_ICCR), ~0U);

    /*
     * EOICR򥻥å
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_EOICR), 0U);
    
    
    for(i = 0; i < TNUM_INT; i++){
        sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+(i*4)), (uint32_t)i);
    }
    
    /*
     * Ƴߤγ׵ػߥե饰ػ
     */
    idf = ~0U;

    /*
     * ͥ٥ޥ0
     */ 
    ipm = 0U;

    /*
     * Ƥγߤޥ
     */ 
    at91sam7s_disable_int(~0U);

    /*
     *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
     */
    bitpat_cfgint = 0U;
    
#ifndef VECTOR_KERNEL    
    /*
     *  㳰٥ơ֥سߥϥɥϿ
     */
    x_install_exc(EXCH_NO_IRQ, interrupt_handler);
    x_install_exc(EXCH_NO_UNDEF, undef_handler);
    x_install_exc(EXCH_NO_SWI, swi_handler);
    x_install_exc(EXCH_NO_PABORT, prefetch_handler);
    x_install_exc(EXCH_NO_DABORT, data_abort_handler);
    x_install_exc(EXCH_NO_FIQ, fiq_handler);
#endif /* VECTOR_KERNEL */
     
    /*
     *  target_fput_log ǽˤʤ褦UART
     */
    at91sam7s_init_uart();    
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

   /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }

    /*
     *  ARM¸νλ
     */
    core_terminate();

    /*
     *  ٤Ƥγߤޥ롥
     */
    at91sam7s_disable_int(~0U);

    /*
     *  ȯĶ¸νλ
     */
    at91sam7s_exit();

    while(1);
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char_t c)
{
    if (c == '\n') {
        at91sam7s_putc('\r');
    }
    at91sam7s_putc(c);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);
    
    /* 
     * äߤػߤ
     */    
    x_disable_int(intno);

    /*
     * ٥ȥꥬ/åȥꥬ
     * IRQΤߥݡȤ
     */
    uint32_t smr_val;

    if((intatr & TA_POSEDGE) != 0U) {
        /*
         * ݥƥ֥å
         */
        smr_val = AIC_SRCTYPE_EXT_POSITIVE_EDGE;
    }else if((intatr & TA_HIGHLEVEL) != 0U) {
        /*
         * ϥ٥ȥꥬ
         */
        smr_val = AIC_SRCTYPE_EXT_HIGH_LEVEL ;
    }else if((intatr & TA_EDGE) != 0U) {
        /*
         * åȥꥬ
         */
        smr_val = AIC_SRCTYPE_INT_EDGE_TRIGGERED;
    }else{
        /*
         * ٥ȥꥬ
         */
        smr_val = AIC_SRCTYPE_INT_LEVEL_SENSITIVE;
    }
    
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SMR+intno*4U), smr_val|intpri);
    
    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);
    }    
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
    syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
