/*
 *
 *  TECS Generator
 *      Generator for TOPPERS Embedded Component System
 *  
 *   Copyright (C) 2008-2012 by TOPPERS Project
 *--
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *  
 *   $Id: rpc_string.h 1763 2012-06-03 08:42:00Z okuma-top $
 */
#ifndef RPC_STRING_H
#define RPC_STRING_H

#include <string.h>

/* GenParamCopy.rb  STRLEN, STRNLEN ؿ */
/* Ǥ short, int, long, int128_t 򥵥ݡȤʤ */

#define   STRLEN8( str )    strlen( (char *)str )

/*
 * STRNLEN
 *  marshaler, unmarshaler  strnlen Ȥ
 *  ХåեСؤΤˤ뤿ᡥ
 *  strnlen  ANSI-C ɸΥ饤֥ؿǤϤʤᡢƤʤ
 *  GNU (Linux), VC++ ǤϻѤǤ뤬MacOS ǤϻѤǤʤ
 *  ¾ȹ OS Ǥμ
 *  ʴؿǤΤ inline ؿȤƼƤ
 */

#ifndef USE_STRNLEN_LIB
#define   STRNLEN8( str, n )    strnlen( (char *)str, n )

#else

Inline size_t
#define   STRNLEN8( str, n )    STRNLEN8_( (uint8_t *)str, n )
STRNLEN8_(const uint8_t *s, size_t maxlen)
{
    size_t  i;
    for( i = 0; i < maxlen; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

#endif

#define	STRLEN16( s )			STRLEN16_( (uint16_t *)s )
#define	STRLEN32( s )			STRLEN32_( (uint32_t *)s )
#define	STRLEN64( s )			STRLEN64_( (uint64_t *)s )

#define	STRNLEN16( s, maxlen )	STRLEN16_( (uint16_t *)s, maxlen )
#define	STRNLEN32( s, maxlen )	STRLEN32_( (uint32_t *)s, maxlen )
#define	STRNLEN64( s, maxlen )	STRLEN64_( (uint64_t *)s, maxlen )

/** STRLENnn_ nn:16,32,64**/
Inline size_t
STRLEN16_(const uint16_t *s )
{
    size_t  i;
    for( i = 0; ; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

Inline size_t
STRLEN32_(const uint32_t *s )
{
    size_t  i;
    for( i = 0; ; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

Inline size_t
STRLEN64_(const uint64_t *s )
{
    size_t  i;
    for( i = 0; ; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

/** STRNLENnn_ nn:16,32,64**/
Inline size_t
STRNLEN16_(const uint16_t *s, size_t maxlen)
{
    size_t  i;
    for( i = 0; i < maxlen; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

Inline size_t
STRNLEN32_(const uint32_t *s, size_t maxlen)
{
    size_t  i;
    for( i = 0; i < maxlen; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}

Inline size_t
STRNLEN64_(const uint64_t *s, size_t maxlen)
{
    size_t  i;
    for( i = 0; i < maxlen; i++ )
        if( *s++ == 0 )
            break;

    return  i;
}


#endif /* RPC_STRING_H */
