#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2012 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: optimize.rb 1725 2012-05-03 05:29:24Z okuma-top $
#++

class Namespace

  #===  ƥ ID ͡ˤդ
  def set_cell_id
    # celltype γƥ ID դ
    @celltype_list.each { |t|
      t.set_cell_id
    }

    # ֥͡ॹڡγƥ ID դ
    @namespace_list.each { |n|
      n.set_cell_id
    }
  end

  def optimize
    # celltype κŬ
    @celltype_list.each { |t|
      t.optimize
    }

    # ֥͡ॹڡκŬ
    @namespace_list.each { |n|
      n.optimize
    }
  end

  def reset_optimize
    # celltype κŬ
    @celltype_list.each { |t|
      t.reset_optimize
    }

    # ֥͡ॹڡκŬ
    @namespace_list.each { |n|
      n.reset_optimize
    }
  end
end

class Celltype

  ID_BASE = 1               # reset_optimize ǥꥻåȤ
  @@ID_BASE = ID_BASE

  #=== ƥ ID ͡ˤդ
  def set_cell_id

    if $verbose then
      print( "=== id for the cells of celltype #{get_namespace_path.to_s} ===\n" ) 
    end

    if $unique_id then
      @id_base = @@ID_BASE   # id 򥷥ƥΤϢ֤ˤ
    else
      @id_base = 1           # base  1 Ϥ
    end

    id_specified_cells = []
    no_id_specified_cells = []

    # ץȥפ
    @cell_list.each{ |c|
      if c.is_generate? then
        # c.set_id( @id_base + @n_cell_gen )
        id = c.get_specified_id
        if id then
          id_specified_cells << c
        else
          no_id_specified_cells << c
        end
        
        # p "#{c.get_name} #{@id_base+@n_cell_gen}"
        @@ID_BASE     += 1
        @n_cell_gen   += 1
      end
    }

    @ordered_cell_list = []   # id = 1 ź 0 ˳Ǽ
    # ID ꤵƤ륻 id ֹͿ
    id_specified_cells.each{ |c|
      id = c.get_specified_id
      if id > 0 then
        if id >= @n_cell_gen then
          cdl_error( "S9999 $1: id too large $2 (max=$3)", c.get_name, id, @n_cell_gen )
          next
        end
      else
        if - id >= @n_cell_gen then
          cdl_error( "S9999 $1: id too large $2 (max=$3)", c.get_name, id, @n_cell_gen )
          next
        end
        id = @n_cell_gen + id + 1
      end

      if @ordered_cell_list[ id - 1 ] then
        cdl_error( "S9999 $1: id number '$2' conflict with $3", c.get_name, id, @ordered_cell_list[ id - 1 ].get_name )
      end
      @ordered_cell_list[ id - 1 ] = c
      # ֹ̤ȤΤ @id_base ä
      c.set_id( @id_base - 1 + id )
      if $verbose then
        print( "#{c.get_name}: id=#{c.get_id}  specified id=#{c.get_specified_id}\n" )
      end
    }

    # ID ꤵƤʤ id ֹͿ
    i = 0
    no_id_specified_cells.each{ |c|
      while( @ordered_cell_list[i] != nil )
        i += 1
      end
      @ordered_cell_list[ i ] = c
      c.set_id( @id_base + i )
      if $verbose then
        print( "#{c.get_name}: id=#{c.get_id}\n" )
      end
    }
    if @n_cell_gen >0 && i >= @n_cell_gen then
      raise "id over id=#{i} N=#{@n_cell_gen}"
    end

  end

  def optimize

    # port λȤ륻륿פοο
    if $verbose then
      print "=== optimizing celltype #{get_namespace_path.to_s} ===\n"
    end

    @port.each{ |port|
      next if port.get_port_type != :CALL

      if $verbose then
        print "optimizing port : #{port.get_name}\n"
      end

      port_cells = []    # Ƥ襻
      port_ports = []    # ƤΥݡ

      # λȤ륻򽸤ʥݡȤ˽
      @cell_list.each{ |cell|

        if ! cell.is_generate? then
          next
        end

        jl = cell.get_join_list
        j = jl.get_item( port.get_name )

        if j then
          if j.get_array_member2 then
            # ƤӸξ硢η򽸤
            j.get_array_member2.each { |j2|
              if j2 then
                port_cells << j2.get_rhs_cell
                port_ports << j2.get_rhs_port   # դΥݡ
              else
                # optional ǡźΤ߽Ƥʤʤ٤ƽʤϡ
                port_cells << nil
                port_ports << nil
              end
            }
          else
            # Ƥη򽸤
            port_cells << j.get_rhs_cell
            port_ports << j.get_rhs_port   # դΥݡ
          end
        else
          # optional ǽƤʤnil Ǥ˲äƤ
          port_cells << nil
          port_ports << nil   # դΥݡ
        end
      }

      # ʣǤ
      port_cells.uniq!
      port_ports.uniq!

      # ƤӸθƤ褬ĤΥݡȤ
      if port_ports.length == 1 then

        # ƤӸ󤬲Ĺξ硢Ŭʤ
             # mikan ƤӸǿޥԶк
             # ˾ޤϡؤΥݥ󥿤Ͼά뤬ĿϽϤ(#_CP_#, #_TCP_#)
             # ĿǤΤǤСޥ (#_NCPA_#)
        next if port.get_array_size == "[]"

        # ƤӸŬ»
        @b_cp_optimized = true

        # Ƥ褬ĤΥ
        if port_cells.length == 1 then

          # ƤӸ optional ǽƤʤޤϼǤϤʤ
          if port_ports[0] == nil || port_ports[0].get_array_size == nil then

            @n_call_port_omitted_in_CB += 1               # CB ǾάƤӸ
            port.set_cell_unique                          # ĤŬ
            port.set_skelton_useless                      # ȥؿ׺Ŭ
            port.set_VMT_useless                          # VMT ׺Ŭ (ľܼؿƽФ)

            if $verbose then
              print "cell_unique, VMT_useless & skelton_useless optimize\n"
            end
          else
            port.set_VMT_useless                          # VMT ׺Ŭ (ȥؿƽФ)

            if $verbose then
              print "VMT_useless optimize\n"
            end
          end

        else  # Ƥ褬ʣΥñΥݡȡ

          # ƤӸ optional ǽƤʤޤϼǤϤʤ
          if port_ports[0] == nil || port_ports[0].get_array_size == nil then
            if ! @singleton then
              port.set_skelton_useless                    # ȥؿ׺Ŭ
              port.set_VMT_useless                        # VMT ׺Ŭ (ȥؿ or ؿƽФ)

              if $verbose then
                print "VMT_useless & skelton useless optimize\n"
              end
            else
              port.set_VMT_useless                           # VMT ׺Ŭ (ȥؿ or ؿƽФ)

              if $verbose then
                print "VMT_useless optimize\n"
              end
            end
          end
        end

        port.set_only_callee( port_ports[0], port_cells[0] )
           # set_cell_unique Ǥʤ cell ϰ̣ʤ

      end

      # debug
      dbgPrint "#{port.get_name} : # of cells : #{port_cells.length}  # of ports : #{port_ports.length}\n"
    }

    # Ŭ
    @port.each{ |port|
      next if port.get_port_type != :CALL

      # ƤӸ¦κŬ
      b_VMT_useless     = port.is_VMT_useless?
      b_skelton_useless = port.is_skelton_useless?

      # λȤ륻򽸤ʥݡȤ˽
      @cell_list.each{ |cell|

        if ! cell.is_generate? then
          next
        end

        jl = cell.get_join_list
        j = jl.get_item( port.get_name )

        if j then    # optional Ƿ礵Ƥʤ nil
          if j.get_array_member2 then
            # ƤӸ
            j.get_array_member2.each { |j2|
              if j2 then
                port2 = j2.get_rhs_port   # դΥݡ
                # ¦κŬǽ
                port2.set_entry_VMT_skelton_useless( b_VMT_useless, b_skelton_useless )
              #else
              #  optional ǸƤӸǤƤʤ
              end
            }
          else
            port2 = j.get_rhs_port      # դΥݡ
            # ¦κŬǽ
            port2.set_entry_VMT_skelton_useless( b_VMT_useless, b_skelton_useless )
          end
        end
      }
    }
  end

  #Celltype# ꥻåȤ
  def reset_optimize
    @@ID_BASE = ID_BASE      # ϰǤ褤
    @id_base = 1             # set_cell_id ǥꥻåȤΤ

    @b_cp_optimized = false  # ƤӸŬ
    @n_call_port_omitted_in_CB = 0 # ƤӸŬˤȤʤäݡȤο
    @n_cell_gen = 0          # Ŀ
    @port.each{ |p|
      p.reset_optimize
    }
    @included_header = {}
  end

  #Celltype# إå include Ƥ뤫
  #hname::Symbol : إå̾
  #RETURN:: bool_t: false 󥯥롼ɤƤʤtrue 󥯥롼ɤƤ
  # #_ISH_#, #_ICT_# ǥإåޤƤ뤫å
  # false ֤ä硢hname ϿơθƤӽФǤ true ֤
  def header_included?( hname )
    if @included_header[ hname ] == nil then
      @included_header[ hname ] = true
      return false
    else
      return true
    end
  end
end


