#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2012 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: pluginModule.rb 1619 2012-01-14 08:02:05Z okuma-top $
#++

#== ץ饰ɤ¦Υ⥸塼
# @@loaded_plugin_list:: {Symbol=>Integer}
module PluginModule

  @@loaded_plugin_list = {}

  #=== ץ饰ɤ
  #return:: true :  false : 
  #
  # Ǥ˥ɤƤΤϡʣƥɤʤ
  # load 㳰ϤΥ᥽åɤǥå false ֤
  def load_plugin( plugin_name, superClass )

    #debug
    # print "PluginModule #{plugin_name}\n"
    begin
      unless @@loaded_plugin_list[ plugin_name.to_sym ] then
        @@loaded_plugin_list[ plugin_name.to_sym ] = 0
        if ( $verbose ) then
          print( "load '#{plugin_name}.rb'\n" )
        end
        # "#{plugin_name}.rb" ɡʥƥѤǤϤʤΤǡfatal 顼ˤʤ
        if require_tecsgen_lib( "#{plugin_name}.rb", false ) == false
          cdl_error( "P2001 $1.rb : fail to load plugin" , plugin_name )
          return false
        end
      end

      plSuper = nil
      eval( "plSuper = #{plugin_name}.superclass" )
      if plSuper != superClass
        cdl_error( "P2002 $1: not kind of $2" ,  plugin_name, superClass.name )
        return false
      end
    rescue Exception => evar
      if $debug then
        p evar.class
        pp evar.backtrace
      end
      cdl_error( "P2003 $1: load failed" , plugin_name )
      return false
    end
    return true
  end

  #=== ץ饰 gen_cdl_file ƤӤ cdl եԤ
  def generate_and_parse plugin_object
    if plugin_object == nil     # ץ饰Υɤ˼ԤƤʴ˥顼
      return
    end
    plugin_name = plugin_object.class.name.to_sym
    if @@loaded_plugin_list[ plugin_name ] == nil
      raise "#{plugin_name} might have different name "
      # ץ饰Υե̾ȡץ饰Υ饹̾㤹
    end
    count = @@loaded_plugin_list[ plugin_name ]
    @@loaded_plugin_list[ plugin_name ] += 1
    tmp_file_name = "#{$gen}/tmp_#{plugin_name}_#{count}.cdl"

    begin
      tmp_file = CFile.open( tmp_file_name, "w" )
    rescue
      cdl_error( "P2004 $1: open error \'$2\'" , plugin_name, tmp_file_name )
    end
    dbgPrint "generate_and_parse: #{plugin_object.class}: gen_cdl_file\n"
    begin
      plugin_object.gen_cdl_file( tmp_file )
    rescue Exception => evar
      cdl_error( "P2005 $1: plugin error in gen_through_cell_code " , plugin_name )
      print_exception( evar )
    end
    begin
      tmp_file.close
    rescue
      cdl_error( "P2006 $1: close error \'$2\'" , plugin_name, tmp_file_name )
    end

    generator = Generator.new
    generator.set_plugin( plugin_object )
    generator.parse( [ tmp_file_name ] )
    generator.finalize
  end

  #=== ץ饰 CDL  POST ɤ
  # tmp_plugin_post_code.cdl ؤν
  def self.gen_plugin_post_code file
    dbgPrint "PluginModule #{@@loaded_plugin_list}\n"
    @@loaded_plugin_list.each{ |plugin_name,count|
      dbgPrint "PluginModule: #{plugin_name}\n"
      eval_str = "#{plugin_name}.gen_post_code( file )"
      if $verbose then
        print "gen_plugin_post_code: #{eval_str}\n"
      end
      begin
        eval( eval_str )
      rescue Exception => evar
        Generator.error( "P2007 $1: fail to generate post code" , plugin_name )

        print_exception( evar )
      end
    }
  end

end
