/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: t_stddef.h 8 2006-10-29 12:01:12Z asp $
 */

/*
 *		TOPPERS̥󥯥롼ɥե
 *
 *  TOPPERSϢΤ٤ƤΥեǥ󥯥롼ɤ٤󥯥롼
 *  ե롥ƼΥͥ䥽եȥʤǶ̤Ѥ뤳Ȥ
 *  Ƥ롥TOPPERSγƼΥͥ䥽եȥʤǶ̤Ѥǡ
 *  ޥʤɤޤࡥ
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡTOPPERS_MACRO_ONLY
 *  Ƥˤꡤޥʳ褦ˤʤäƤ롥ޤ
 *  NULL
 *
 *  Υե򥤥󥯥롼ɤ˥󥯥롼ɤƤ٤ե
 *  Ϥʤ
 */

#ifndef TOPPERS_T_STDDEF_H
#define TOPPERS_T_STDDEF_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  åȰ¸
 */
#include "target_stddef.h"

/*
 *  C/EC++throw()н褹뤿
 */
#if !defined(__cplusplus) || defined(__embedded_cplusplus)
#define throw()
#endif

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȰ¸ΥǡȥޥΥǥե
 */
#ifndef TOPPERS_bool
#define TOPPERS_bool	int				/* ֡뷿 */
#endif /* TOPPERS_bool */

#ifndef TOPPERS_size
	// #define TOPPERS_size	uintptr_t		/*  */
#define TOPPERS_size	long		/*  */
#endif /* TOPPERS_size */

#ifndef TOPPERS_fp
struct TOPPERS_dummy_t { int TOPPERS_dummy_field; };
typedef	void			(*TOPPERS_fp_t)(struct TOPPERS_dummy_t);
#define TOPPERS_fp		TOPPERS_fp_t	/* ץεư */
#endif /* TOPPERS_fp */

#ifndef CHAR_BIT
#define CHAR_BIT		8				/* charΥӥåȿ */
#endif /* CHAR_BIT */

/*
 *  ̥ǡ
 */
typedef unsigned char	char_t;		/* */
typedef signed int		int_t;		/* ʥդ */
typedef unsigned int	uint_t;		/* ʥ̵ */

typedef signed long		long_t;		/* ĹΥդ */
typedef unsigned long	ulong_t;	/* ĹΥ̵ */

typedef TOPPERS_bool	BOOL;		/*  */
typedef	TOPPERS_size	SIZE;		/* ΰΥ */
typedef	TOPPERS_fp		FP;			/* ץεư */

typedef int_t			FN;			/* ǽ */
typedef	int_t			ER;			/* 顼 */
typedef	int_t			ID;			/* ֥ȤIDֹ */
typedef	uint_t			ATR;		/* ֥Ȥ° */
typedef	uint_t			STAT;		/* ֥Ȥξ */
typedef	uint_t			MODE;		/* ӥư⡼ */
typedef	int_t			PRI;		/* ͥ */

typedef	int_t			TMO;		/* ॢȻ */
typedef	uint_t			RELTIM;		/* л */
typedef	ulong_t			SYSTIM;		/* ƥ */
typedef	ulong_t			SYSUTIM;	/* ǽɾѥƥ */

typedef	int_t			ER_BOOL;	/* 顼ɤޤϿ */
typedef	int_t			ER_ID;		/* 顼ɤޤIDֹ */
typedef	int_t			ER_UINT;	/* 顼ɤޤ̵ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  
 *
 *  TOPPERS_MACRO_ONLYλˤϡNULLʤϡƥॳ
 *  ե졼եˤNULLƤϤʤ
 *  Ǥ롥
 */
#ifndef TOPPERS_MACRO_ONLY
#ifndef NULL
#define NULL		0			/* ̵ݥ */
#endif /* NULL */
#endif /* TOPPERS_MACRO_ONLY */

#define TRUE		1			/*  */
#define FALSE		0			/*  */
#define E_OK		0			/* ｪλ */

/*
 *  ᥤ󥨥顼
 */
#define E_SYS		(-5)		/* ƥ२顼 */
#define E_NOSPT		(-9)		/* ̤ݡȵǽ */
#define E_RSFN		(-10)		/* ͽǽ */
#define E_RSATR		(-11)		/* ͽ° */
#define E_PAR		(-17)		/* ѥ᡼顼 */
#define E_ID		(-18)		/* IDֹ */
#define E_CTX		(-25)		/* ƥȥ顼 */
#define E_MACV		(-26)		/* ꥢȿ */
#define E_OACV		(-27)		/* ֥ȥȿ */
#define E_ILUSE		(-28)		/* ӥ */
#define E_NOMEM		(-33)		/* ­ */
#define E_NOID		(-34)		/* IDֹ­ */
#define E_OBJ		(-41)		/* ֥Ⱦ֥顼 */
#define E_NOEXS		(-42)		/* ֥̤ */
#define E_QOVR		(-43)		/* 塼󥰥Сե */
#define E_RLWAI		(-49)		/* Ԥ֤ζ */
#define E_TMOUT		(-50)		/* ݡ󥰼Ԥޤϥॢ */
#define E_DLT		(-51)		/* Ԥ֥Ȥκ */
#define E_CLS		(-52)		/* Ԥ֥ȤξѲ */
#define E_WBLK		(-57)		/* Υ֥å󥰼դ */
#define E_BOVR		(-58)		/* ХåեСե */

/*
 *  ֥°
 */
#define TA_NULL		0U			/* ֥°ꤷʤ */

/*
 *  ॢȻ
 */
#define TMO_POL		0			/* ݡ */
#define TMO_FEVR	(-1)		/* ʵԤ */
#define TMO_NBLK	(-2)		/* Υ֥å */

/*
 *  顼ʬޥ
 *
 *  ʲΥޥϡդ2ɽƤꡤե
 *  黻ҡ>>ˤѥեȤ뤳ȤꤷƤ롥Ǥʤȯ
 *  Ǥϡtarget_stddef.hǤ񤭤ʤФʤʤ
 *
 *  MERCDޥϡᥤ󥨥顼ɤǤ뤳ȤꤷƤ롥
 *  Ǥʤ硤2Ĥפʤʤ롥
 */
#ifndef ERCD
#define ERCD(mercd, sercd) \
				((ER)((((uint_t) sercd) << 8) | (((uint_t) mercd) & 0xffU)))
#endif /* ERCD */

#ifndef MERCD
#ifdef INT8_MAX
#define MERCD(ercd)		((ER)((int8_t)(ercd)))
#else /* INT8_MAX */
#define MERCD(ercd)		((ER)(((uint_t) ercd) | ~0xffU))
#endif /* INT8_MAX */
#endif /* MERCD */

#ifndef SERCD
#define SERCD(ercd)		((ER)((ercd) >> 8))
#endif /* SERCD */

/*
 *  ˴ؤФΥޥ
 */
#ifndef offsetof
#define	offsetof(structure, field)	((uintptr_t) &(((structure *) 0)->field))
#endif /* offsetof */

#ifndef alignof
#define alignof(type)	offsetof(struct { char field1; type field2; }, field2)
#endif /* alignof */

/*
 *  饤ȥåޥ
 */
#ifndef ALIGN_TYPE
#define ALIGN_TYPE(addr, type) \
						((((uintptr_t)(addr)) & (alignof(type) - 1)) == 0U)
#endif /* ALIGN_TYPE */

/*
 *  assertޥ
 */
#undef assert
#ifndef NDEBUG
#define assert(exp)		((void)((exp) ? 0 : (TOPPERS_assert_fail(#exp, \
							__FILE__, __LINE__), TOPPERS_assert_abort(), 0)))
#else /* NDEBUG */
#define assert(exp)		((void) 0)
#endif /* NDEBUG */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_T_STDDEF_H */
