/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_support.S 1870 2010-07-26 13:09:18Z ertl-honda $
 */

/*
 *        ¸⥸塼 ֥ARMѡ
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "offset.h"

/*
 * 㳰٥
 */
    .section .vector,"a"
    .global vector_table
vector_table:
    ldr pc, reset_vector       /* ꥻå             */
    ldr pc, undef_vector       /* ̤̿           */
    ldr pc, swi_vector         /* եȥ   */
    ldr pc, prefech_vector     /* ץեåܡ */
    ldr pc, data_abort_vector  /* ǡܡ       */
    ldr pc, reset_vector
    ldr pc, irq_vector         /* IRQ                  */
    ldr pc, fiq_vector         /* FIQ                  */


/*
 *  㳰٥̿ᤫ黲Ȥ
 *  襢ɥ쥹
 */
    .global vector_ref_tbl
vector_ref_tbl:
reset_vector:
    .long   start
undef_vector:
    .long   undef_handler
swi_vector:
    .long   swi_handler
prefech_vector:
    .long   prefetch_handler
data_abort_vector:
    .long   data_abort_handler
irq_vector:
    .long   irq_handler
fiq_vector:
    .long   fiq_handler

/*
 *  ǥѥå
 *
 */
    .text
    .align 2
    .globl dispatch
dispatch:
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥
     */
    stmfd sp!, {r4 - r11,lr}           /* 쥸¸ */
    ldr   r0, =p_runtsk                /* p_runtskɤ߹ */
    ldr   r1, [r0]
    str   sp, [r1,#TCB_sp]             /* å¸ */
    adr   r2, dispatch_r
    str   r2, [r1,#TCB_pc]             /* ¹ԺƳϤ¸ */
    b     dispatcher

dispatch_r:
    ldmfd sp!,{r4 - r11,lr}     /* 쥸 */
    /*
     * 㳰롼εư
     * dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0,[r1,#TCB_enatex]
    tst   r0,#TCB_enatex_mask
    beq   dispatch_r_1          /* enatex  false ʤ꥿ */
    ldr   r0,[r1,#TCB_texptn]   /* texptn 0Ǥʤ         */
    tst   r0,r0                 
    bne   call_texrtn           /* 㳰롼θƤӽФ */
dispatch_r_1:
    bx    lr


/*
 *  ǥѥåưϡcpu_support.S
 */
    .globl start_dispatch
start_dispatch:
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
     *
     *  dispatcherϡCPUå֡ʥǥΡ˳ͥ٥ޥ
     *  ֡㳰ʳ/CPU㳰ˤΥͥȲ0ǸƤӽФ     
     *  target_initializeǤϡʥǥΡ˳ͥ٥ޥ
     *  ȤͥγߤǤFIQĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     *  
     */    
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) /* CPUå֤ */
    ldr   r2, =excpt_nest_count            /* 㳰ʳ/CPU㳰ˤΥͥȲ */
    mov   r0, #0                           /* 0                              */
    str   r0, [r2]
    b     dispatcher_0

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl exit_and_dispatch
exit_and_dispatch:
    /* ǥѥåΡdispatcherˤ */    

/*
 *  ǥѥå
 */
dispatcher:
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
     *
     *  ʤѡХ⡼ɡIRQػߡdisdspfalsedspflg
     *  trueȤʤäƤ롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
     */
#ifdef LOG_DSP_ENTER
    ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
    ldr   r0, [r1]        
    bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
dispatcher_0:
    ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
    ldr   r1, [r0]
    ldr   r2, =p_runtsk   
    str   r1, [r2]        
    cmp   r1, #0            /* p_runtskNULLʤdispatcher_1 */
    beq   dispatcher_1             
    ldr   sp, [r1,#TCB_sp]  /* å */
#ifdef LOG_DSP_LEAVE
    mov   r0, r1            /* p_runtskѥ᡼ */
    mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
    bl    log_dsp_leave
    mov   r1, r4
#endif /* LOG_DSP_LEAVE */
    ldr   r4, [r1,#TCB_pc]  /* ¹ԺƳϤ   */    
    bx    r4
dispatcher_1:
    /*
     * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
     * 򤹤
     */
    ldr   r0, =_kernel_istk            /* 󥿥ƥȤΥå */
    ldr   sp, [r0]    
    ldr   r1, =_kernel_istksz
    ldr   r3, [r1]
    add   sp, sp, r3
    ldr   r2, =reqflg                  /* r2 <- reqflg */
    ldr   r3, =excpt_nest_count        /* r3 <-excpt_nest_count */
    mov   r0, #0
    mov   r1, #1
dispatcher_2:
    /*
     *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
     *
     *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
     *  ߽ˤɤΥåȤȤβȡ
     *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
     *
     *  ץåԤ˰ܹԤȡߵĤȤϡԲ
     *  ʬ˹Ԥʤɬפ롥
     *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
     *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
     *  ˤ⤫餺ץåԤˤʤäƤޤ
     *
     *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
     *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
     *  ݤưͤ˹פʤʤ롥
     *
     *  åȤˤäƤϡϥ⡼˰ܹԤ뤿ᡤɸˡ
     *  ۤʤ礬ɬפʾ礬롥
     *  Τ褦ʥåȤǤϡåȰ¸ˤơTOPPERS_CUSTOM_IDLE
     *  ֥ޥȤơtoppers_asm_custom_idle Ѱ
     *  Ф褤toppers_asm_custom_idle εҤˤäƤϡΥ쥸
     *  ϻѤǤʤ
     *     r0, r1, r2, r3, sp 
     *
     */
    str   r1, [r3]                          /* excpt_nest_count = 1 */

#ifdef TOPPERS_CUSTOM_IDLE
    toppers_asm_custom_idle
#else
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET) /* ߵ(ƥ⡼) */
    nop
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) /* CPUå(ƥ⡼) */
#endif /* TOPPERS_CUSTOM_IDLE */

    ldr   r6, [r2]        /* reqflgfalseʤdispatcher_2 */
    cmp   r6, #0          
    beq   dispatcher_2                 
    str   r0, [r2]        /* reqflgfalse */
    str   r0, [r3]        /* excpt_nest_count = 0 */
    b     dispatcher_0


/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl call_exit_kernel
call_exit_kernel:
    msr  cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET|CPSR_IRQ_BIT|CPSR_FIQ_BIT) 
    ldr  r0, =_kernel_istkpt       /* 󥿥ƥȤΥå */
    ldr  sp, [r0]
    b     exit_kernel


/*
 *  ϻ
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 */
    .text
    .globl start_r
start_r:
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET) /* CPUå֤ */
    ldr   lr, =ext_tsk                      /*  */
    ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
    ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
    ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
    mov   pc, r1 


/*
 *  ߥϥɥ/CPU㳰ϥɥи
 *
 *  ret_intϡߥϥɥ餫äľ˼¹Ԥ롼ǡ
 *  ߥϥɥ齪λ塤åȰ¸ν¹Ԥ塤
 *  ͥγߤػߡåΥåˤ
 *  ֤ǸƤӽФ롥
 */
    .text
    .global ret_int
    .global ret_exc
ret_int:
ret_exc:
    /*
     *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
     */        
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]
    cmp   r2, #0                  /* 褬󥿥ƥȤʤ */
    bne   ret_int_1               /* ˥꥿                   */

    /*
     *  reqflgå˳ߤػߤΤϡreqflgå
     *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
     *  줿ˡ˥ǥѥåʤȤ꤬뤿
     *  Ǥ롥
     */
    ldr   r0, =reqflg
    ldr   r1, [r0]
    cmp   r1, #0                  /* reqflgtrueǤret_int_2 */
    bne   ret_int_2
ret_int_1:
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤʤ
     *  ʤʤ    
     *  ARMǤϡCPSRIRQӥåȤCPUå֤Ȥ뤿ᡤñ˥꥿
     *  Ф褤
     */                
    ldmfd sp!,{r1}              /* CPSR */
    msr   spsr, r1              /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */

    
ret_int_2:
ret_int_3:
    /*
     *  ؤϡCPU㳰ϥɥνиʬƤ롥
     *
     *  Ǥϡ褬Ǥꡤåϡåξ
     *  ˥å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ץåϡѡХ⡼ɡͥγߤػ
     *  ֤ȤʤäƤ롥
     */    
    ldr   r0, =reqflg    /* reqflgfalse */
    mov   r1, #0
    str   r1, [r0]
    /*
     *  CPUå֤˰ܹԤ롥
     *
     *  λCPUå֤ȤΤϡdispatcherʬȡ
     *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
     *  Ǥ롥
     *
     *  ARMǤϡCPSRIRQӥåȤCPUå֤ɽ뤿ᡤǤϡ
     *  ä˲Ԥʤ
     */
    
    /*
     *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgtrueˤ뤿Ǥ롥
     */

    ldr   r0, =p_runtsk       /* p_runtsk r1ɤ߹ */
    ldr   r1, [r0]
    ldr   r0, =dspflg
    ldr   r2, [r0]
    cmp   r2, #0              /* dspflgfalseʤret_int_4 */
    beq   ret_int_4
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɤ߹ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
    beq   ret_int_4           /*                    ret_int_4 */
    stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
    str   sp, [r1,#TCB_sp]    /* å¸ */
    adr   r0, ret_int_r       /* ¹ԺƳϤ¸   */
    str   r0, [r1,#TCB_pc]
    b     dispatcher

ret_int_r: 
    ldmfd sp!, {r4-r11}       /* 쥸 */    
ret_int_4:
    /*
     *  enatextrueǡtexptn0ǤʤС㳰롼
     *  ƤӽФ
     *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
     */
    ldrb  r0, [r1,#TCB_enatex]
    tst   r0, #TCB_enatex_mask
    beq   ret_int_5              /* enatex  false ʤ ret_int5 */
    ldr   r0, [r1,#TCB_texptn]   /* texptn               */
    tst   r0, r0                 /* texptn 0̵         */
    blne  call_texrtn            /* 㳰롼θƤӽФ */            
ret_int_5:
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
     *  ˤ롥ARMCPSRIRQӥåȤˤäCPUå֤ɽƤ
     *  뤿ᡤΤޤޥ꥿󤹤Ф褤
     */        
    ldmfd sp!, {r0}             /* spsr  */
    msr   spsr,r0               /* cpsrspsr */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /*  ^դʤΤǡcpsr <- spsr */    
    

/*
 * CPU㳰ϥɥ
 *
 * CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥
 * 
 */

/*
 *  ̤̿ 㳰ϥɥ
 */
    .text
    .align 2
    .global undef_handler
undef_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿̤⡼ɤ
     */
    msr   cpsr, #(CPSR_UND|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_UNDEF
    b     target_exc_handler


/*
 *  SWI 㳰ϥɥ
 */
    .text
    .align 2
    .global swi_handler
swi_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     *  ѡХ⡼ɤCPUå֤Ȥ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_SWI
    b     target_exc_handler


/*
 *  ץեåܡ 㳰ϥɥ
 */
    .text
    .align 2
    .global prefetch_handler
prefetch_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr, #(CPSR_ABT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_PABORT
    b     target_exc_handler


/*
 *  ǡܡ 㳰ϥɥ
 */
    .text
    .align 2
    .global data_abort_handler
data_abort_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿˥ܡȥ⡼ɤ
     */
    msr   cpsr, #(CPSR_ABT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_DABORT
    b     target_exc_handler


#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ 㳰ϥɥ
 */
    .text
    .align 2
    .global fiq_handler
fiq_handler:
    /* 
     *  ư⡼(ѡХ⡼)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pcϥߡ */

    /*
     * spsrϤ뤿FIQ⡼ɤ
     */
    msr   cpsr, #(CPSR_FIQ|CPSR_FIQ_BIT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_FIQ
    b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

/*
 *  Ԥ
 */
    .globl _sil_dly_nse
_sil_dly_nse:
    sub   r0, r0, #SIL_DLY_TIM1
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
_sil_dly_nse1:
    sub   r0, r0, #SIL_DLY_TIM2
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
