/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tControlTaskBody_template.c => src/tControlTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * receiveBufferSize uint8_t          ATTR_receiveBufferSize
 * currentForward   int16_t          VAR_currentForward
 * currentTurn      int16_t          VAR_currentTurn 
 * obstcleFlag      bool_t           VAR_obstcleFlag 
 * receiveBuffer    uint8_t*         VAR_receiveBuffer
 *
 * ƤӸؿ #_TCPF_#
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int32_t pwm );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int32_t pwm );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_initialize( );
 *   void           cBalancer_setGyroOffset( uint16_t gyroOffset );
 *   void           cBalancer_calculationPWM( int16_t forward, int16_t turn, int32_t leftRevolution, int32_t rightRevolution, int8_t* pwm_l, int8_t* pwm_r );
 * call port : cBluetooth  signature: sBluetooth context: task
 *   void           cBluetooth_open( );
 *   bool_t         cBluetooth_getLocalAddress( uint8_t* address );
 *   bool_t         cBluetooth_getDeviceName( uint8_t* name );
 *   bool_t         cBluetooth_setDeviceName( const uint8_t* name );
 *   bool_t         cBluetooth_setFactorySetting( );
 *   uint8_t        cBluetooth_getStatus( );
 *   int32_t        cBluetooth_initializeMaster( const uint8_t* address, const uint8_t* pin );
 *   int32_t        cBluetooth_initializeSlave( const uint8_t* pin );
 *   void           cBluetooth_terminateConnection( );
 *   uint32_t       cBluetooth_sendPacket( const uint8_t* buffer, uint32_t length );
 *   uint32_t       cBluetooth_readPacket( uint8_t* buffer, uint32_t length );
 *
 * #[</PREAMBLE>]# */

#include "tControlTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

#include "ecrobot_base.h"
#include "ecrobot_private.h"
#include "ecrobot_interface.h"
#include "tBluetooth.h"

// Ȥꤢ
static void
dataLogger(int8_t data1, int8_t data2)
{
	uint8_t data_log_buffer[32];
	SYSTIM current;

	get_tim(&current);

	*((uint32_t *)(&data_log_buffer[0]))  = (uint32_t)current;
	*((int8_t *)(&data_log_buffer[4]))  =  (int8_t)data1;
	*((int8_t *)(&data_log_buffer[5]))  =  (int8_t)data2;
	*((uint16_t *)(&data_log_buffer[6]))  = (uint16_t)ecrobot_get_battery_voltage();
	*((int32_t *)(&data_log_buffer[8]))  = (int32_t)nxt_motor_get_count(0);
	*((int32_t *)(&data_log_buffer[12])) = (int32_t)nxt_motor_get_count(1);
	*((int32_t *)(&data_log_buffer[16])) = (int32_t)nxt_motor_get_count(2);
	*((int16_t *)(&data_log_buffer[20])) = (int16_t)sensor_adc(0);
	*((int16_t *)(&data_log_buffer[22])) = (int16_t)sensor_adc(1);
	*((int16_t *)(&data_log_buffer[24])) = (int16_t)sensor_adc(2);
	*((int16_t *)(&data_log_buffer[26])) = (int16_t)sensor_adc(3);
	*((int32_t *)(&data_log_buffer[28])) = (int32_t)ecrobot_get_sonar_sensor(NXT_PORT_S3);
	
	cBluetooth_sendPacket(data_log_buffer, 32);
}

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tControlTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	int32_t leftRevolution, rightRevolution;
	int8_t pwm_l, pwm_r;

	/*
	 *  BluetoothΥѥåȤɤ
	 */
	//cBluetooth_readPacket(VAR_receiveBuffer, ATTR_receiveBufferSize);

	/*
	 *  ®٤ͤ
	 */
	VAR_currentForward = -(int16_t)VAR_receiveBuffer[0];
	VAR_currentTurn = (int16_t)VAR_receiveBuffer[1];

	/*
	 *  㳲ʪΤϤǸ
	 */
	if(VAR_obstcleFlag){
		VAR_currentForward = -100;
		VAR_currentTurn = 0;
	}

	/*
	 *  ⡼βž
	 */
	cLeftMotor_getRevolution(&leftRevolution);
	cRightMotor_getRevolution(&rightRevolution);

	/*
	 *  Ωѥѥ᡼η׻
	 */
	cBalancer_calculationPWM(VAR_currentForward, VAR_currentTurn, leftRevolution, rightRevolution, &pwm_l, &pwm_r);

	/*
	 *  ⡼PWMͤ򥻥å
	 */
	cLeftMotor_setPWM(pwm_l);
	cRightMotor_setPWM(pwm_r);
	if (ecrobot_get_button_state() == ENTER_PRESSED){
		cLeftMotor_setPWM(0);
		cRightMotor_setPWM(0);
	}

	/*
	 *  Bluetoothǥǡ
	 */
	//dataLogger(VAR_currentForward, VAR_currentTurn);
}

/* #[<ENTRY_PORT>]# eNotifyObstacle
 * entry port: eNotifyObstacle
 * signature:  sNotify
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eNotifyObstacle_body
 * name:         eNotifyObstacle_body
 * global_name:  tControlTaskBody_eNotifyObstacle_body
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eNotifyObstacle_body(bool_t flag)
{
	VAR_obstcleFlag = flag;
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
