/*
 *  TECS Generator
 *      Generator for TOPPERS Embedded Component System
 *  
 *   Copyright (C) 2008-2012 by TOPPERS Project
 *--
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *  
 *   $Id: tDataqueueAdaptor_inline.h 1753 2012-06-03 01:07:25Z okuma-top $
 */

/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * #[</PREAMBLE>]# */

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eChannel
 * entry port: eChannel
 * signature:  sChannel
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eChannel_open
 * name:         eChannel_open
 * global_name:  tDataqueueAdaptor_eChannel_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_close
 * name:         eChannel_close
 * global_name:  tDataqueueAdaptor_eChannel_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_reset
 * name:         eChannel_reset
 * global_name:  tDataqueueAdaptor_eChannel_reset
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	cEventflag_clear( 0 );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_send
 * name:         eChannel_send
 * global_name:  tDataqueueAdaptor_eChannel_send
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int     i;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	ercd = 0;
	for( i = 0; i < size; i++ )
		ercd |= cDataqueue_send( (intptr_t)((uint8_t)buf[ i ]) );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_flush
 * name:         eChannel_flush
 * global_name:  tDataqueueAdaptor_eChannel_flush
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_flush(CELLIDX idx, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_receive
 * name:         eChannel_receive
 * global_name:  tDataqueueAdaptor_eChannel_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER_UINT
eChannel_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	ER_UINT ercd = E_OK;
	CELLCB	*p_cellcb;
	intptr_t data;
	int     i;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	/* printf( "DQA: receive(%d) ", size ); */
	for( i = 0; i < size; i++ ){
		ercd = cDataqueue_receive( &data );
		buf[i] = (int8_t)data;
		if( ercd != E_OK )
			break;
	}
	if( ercd != E_OK )
		return(ercd);
	else
		return i;
}

/* #[<ENTRY_FUNC>]# eChannel_end_receive
 * name:         eChannel_end_receive
 * global_name:  tDataqueueAdaptor_eChannel_end_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

